#line 1 "Arduino_FM3.ino"
#include <Toppers.h>
#include "Arduino.h"
void  cyc_handler( void );
void  sub_task( void );
void setup();
void loop();
#line 2
Toppers rtos;

/* Blink without Delay
 
 Turns on and off a light emitting diode(LED) connected to a digital  
 pin, without using the delay() function.  This means that other code
 can run at the same time without being interrupted by the LED code.
 
 The circuit:
 * LED attached from pin 13 to ground.
 * Note: on most Arduinos, there is already an LED on the board
 that's attached to pin 13, so no hardware is needed for this example.
 
 
 created 2005
 by David A. Mellis
 modified 8 Feb 2010
 by Paul Stoffregen
 
 This example code is in the public domain.

 
 http://www.arduino.cc/en/Tutorial/BlinkWithoutDelay
 */

// constants won't change. Used here to 
// set pin numbers:
const int ledPinOnboard =  13;      // the number of the LED pin
const int swPinOnboard  =  16;      // the number of the Push button pin

// Variables will change:
int ledState = LOW;             // ledState used to set the LED
long previousMillis = 0;        // will store last time LED was updated

long switch_counter = 0 ;

// the follow variables is a long because the time, measured in miliseconds,
// will quickly become a bigger number than can be stored in an int.
long interval = 500;           // interval at which to blink (milliseconds)

int  cyc_flag ;
char  cyc_char ;
char  disp_msg[128];

void  cyc_handler( void )
{
    if( cyc_flag == 0 ) {
        cyc_flag = 1 ;
        cyc_char = '#' ;
    } else {
        cyc_flag = 0 ;
        cyc_char = ' ' ;
    }
}


void  sub_task( void )
{
    while( 1 ) {
        delay( 200 ) ;
    }
}

void setup() {

   int  i ;

  // set the digital pin as output:
  // pinMode(ledPinOnboard, OUTPUT);

    for( i=0 ; i<20 ; i++ ) {
        if( i==13 ) {
            continue ;
        }
        pinMode( i, OUTPUT ) ;
    }

    for( i=0 ; i<20 ; i++ ) {
        if( i==13 ) {
            continue ;
        }
        digitalWrite( i, LOW ) ;
    }

    cyc_flag = 0 ;
    cyc_char = ' ' ;
    rtos.sta_tsk( (void *)sub_task ) ;
    rtos.sta_cyc( (void *)cyc_handler ) ;
}


void loop()
{
    unsigned long currentMillis = millis();
    int  i ;

    if(currentMillis - previousMillis > interval) {
        previousMillis = currentMillis;   
    }

    for( i=0 ; i<20 ; i++ ) {
        if( i==13 ) {
            continue ;
        }
        digitalWrite( i, HIGH ) ;
    }

    for( i=0 ; i<20 ; i++ ) {
        if( i==13 ) {
            continue ;
        }
        digitalWrite( i, LOW ) ;
    }
}

