#line 1 "Arduino_Toppers1.ino"
#include <Toppers.h>
#include "Arduino.h"
void  cyc_handler( void );
void  sub_task( void );
void setup();
void loop();
#line 2
Toppers rtos;

#include <LiquidCrystal.h>
LiquidCrystal lcd(2, 3, 4, 5, 6, 7);

/* Blink without Delay
 
 Turns on and off a light emitting diode(LED) connected to a digital  
 pin, without using the delay() function.  This means that other code
 can run at the same time without being interrupted by the LED code.
 
 The circuit:
 * LED attached from pin 13 to ground.
 * Note: on most Arduinos, there is already an LED on the board
 that's attached to pin 13, so no hardware is needed for this example.
 
 
 created 2005
 by David A. Mellis
 modified 8 Feb 2010
 by Paul Stoffregen
 
 This example code is in the public domain.

 
 http://www.arduino.cc/en/Tutorial/BlinkWithoutDelay
 */

// constants won't change. Used here to 
// set pin numbers:
const int ledPinOnboard =  13;      // the number of the LED pin
const int swPinOnboard  =  16;      // the number of the Push button pin

// Variables will change:
int ledState = LOW;             // ledState used to set the LED
long previousMillis = 0;        // will store last time LED was updated

long switch_counter = 0 ;

// the follow variables is a long because the time, measured in miliseconds,
// will quickly become a bigger number than can be stored in an int.
long interval = 500;           // interval at which to blink (milliseconds)

int  cyc_flag ;
char  cyc_char ;

void  cyc_handler( void )
{
    if( cyc_flag == 0 ) {
        cyc_flag = 1 ;
        cyc_char = '#' ;
    } else {
        cyc_flag = 0 ;
        cyc_char = ' ' ;
    }
}


void  sub_task( void )
{
    while( 1 ) {
        lcd.setCursor( 15, 0 ) ;
        lcd.print( &cyc_char );
        delay( 200 ) ;
    }
}

void setup() {

  // set the digital pin as output:
  // pinMode(ledPinOnboard, OUTPUT);
  pinMode(swPinOnboard, INPUT ) ;

    lcd.begin(16, 2);
    lcd.setCursor( 3, 0 ) ;
    lcd.print("Hello");
    lcd.setCursor( 4, 1 ) ;
    lcd.print("Arduino!");

    cyc_flag = 0 ;
    cyc_char = ' ' ;
    rtos.sta_tsk( (void *)sub_task ) ;
    rtos.sta_cyc( (void *)cyc_handler ) ;
}


void loop()
{
  // here is where you'd put code that needs to be running all the time.

  // check to see if it's time to blink the LED; that is, if the 
  // difference between the current time and last time you blinked 
  // the LED is bigger than the interval at which you want to 
  // blink the LED.
  unsigned long currentMillis = millis();
 
  if(currentMillis - previousMillis > interval) {
    // save the last time you blinked the LED 
    previousMillis = currentMillis;   

    // digitalWrite(ledPinOnboard, (switch_counter>>0)&0x01);
    if( (switch_counter & 0x01) != 0 ) {
      lcd.setCursor( 14, 0 ) ;
      lcd.print("*");
    } else {
      lcd.setCursor( 14, 0 ) ;
      lcd.print(" ");
    }
    switch_counter++ ;
  }
}


