/*
  Copyright (c) 2011 Arduino.  All right reserved.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  See the GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "Arduino.h"

#ifdef __cplusplus
extern "C" {
#endif


unsigned long  tran_get_tim( void ) ;
void  tran_delay( unsigned long  ms ) ;


uint32_t millis( void )
{
#if 0
// todo: ensure no interrupts
	return GetTickCount() ;
#else
        return (uint32_t)tran_get_tim() ;
#endif
}

uint32_t micros( void )
{
#if 0
    uint32_t ticks ;
    uint32_t count ;

    SysTick->CTRL;
    do {
        ticks = SysTick->VAL;
        count = GetTickCount();
    } while (SysTick->CTRL & SysTick_CTRL_COUNTFLAG_Msk);

    return count * 1000 + (SysTick->LOAD + 1 - ticks) / (SystemCoreClock/1000000) ;
#else
    return (uint32_t)(tran_get_tim() * 1000) ;
#endif
}

void delay( uint32_t ms )
{
#if 0
    uint32_t end = GetTickCount() + ms;
    while (GetTickCount() < end)
    	yield();
#else
    tran_delay( (unsigned long)ms ) ;
#endif
}

void delayMicroseconds( uint32_t us )
{
#if 0
    uint32_t start = micros();
    while ((micros() - start) < us)
        ;
#else
    tran_delay( (unsigned long)(us/1000) ) ;
#endif
}

#if defined ( __ICCARM__ ) /* IAR Ewarm 5.41+ */
extern signed int putchar( signed int c ) ;
/**
 * \brief
 *
 * \param c  Character to output.
 *
 * \return The character that was output.
 */
extern WEAK signed int putchar( signed int c )
{
    return c ;
}
#endif /* __ICCARM__ */

#ifdef __cplusplus
}
#endif
