/*
  Copyright (c) 2011 Arduino.  All right reserved.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  See the GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "Arduino.h"

#ifdef __cplusplus
 extern "C" {
#endif

void  fm3_pinMode( unsigned int ulPin, unsigned int ulMode );
void  fm3_digitalWrite( unsigned int ulPin, unsigned int ulVal );
int   fm3_digitalRead( unsigned int ulPin );

extern void pinMode( uint32_t ulPin, uint32_t ulMode )
{
    unsigned int  mode = 0xffff ;

    switch( ulMode ) {
    case INPUT:
        mode = 0 ;
        break ;
    case OUTPUT:
        mode = 1 ;
        break ;
    case INPUT_PULLUP:
        mode = 2 ;
        break ;
    }
    fm3_pinMode( ulPin, mode ) ;
}

extern void digitalWrite( uint32_t ulPin, uint32_t ulVal )
{
    fm3_digitalWrite( ulPin, ulVal ) ;
}

extern int digitalRead( uint32_t ulPin )
{
    if( fm3_digitalRead( ulPin ) == 1 )
    {
        return HIGH ;
    }

    return LOW ;
}

#ifdef __cplusplus
}
#endif

