/*
 *  for MB9BF618T on FRK-FM3
 * 
 *   Copyright (C) by Y.Ishioka.
 */
#include "mb9b610t.h"
#include "fm3.h"

/// @cond 0
/**INDENT-OFF**/
#ifdef __cplusplus
extern "C" {
#endif
/**INDENT-ON**/
/// @endcond

#if 0


/***********************************************************/
/*
 * ADC initialize
 */
void  adc_init( void )
{
    FM3_GPIO->ADE = FM3_GPIO->ADE & ~0x00000000 ;

    /* ENBL=1 */
    ADC->ADCEN = 0x01 ;
    while( (ADC->ADCEN & 0x02) == 0 ) ;

    /* AN16 - AN21 =1 */
    ADC->SCIS1 |= 0x003f ;

    /* sampling time 1/HCLK * (31+1)*256+1 */
    ADC->ADST0 = 0xff ;
    ADC->ADCR = 0x00 ;

    /* ADC stop */
    ADC->ADSR = 0x80 ;

    /* RPT=0 SSTR=0 */
    ADC->SCCR = 0x00 ;
}


/*
 *  start ADC convert
 *    return : == 0 : success
 *           : != 0 : fail
 */
int  adc_start( int port )
{
    /* RPT=0 -> repeat, SSTR=1 -> scan start */
    ADC->SCCR |= 0x01 ;

    return( 0 ) ;
}


/*
 *  read ADC result data
 *    return : == 0xffffffff : fail or not completed
 *             others        : result data
 */
unsigned int  adc_read( int port )
{
    unsigned int  result ;

    result = (unsigned int)ADC->SCFD ;
    if( (result & 0x00001000) != 0 ) {
        result = 0xffffffff ;
    } else {
        if( (result & 0x0000001f) == port ) {
            result >>= 20 ;
        } else {
            result = 0xffffffff ;
        }
    }

    return( result ) ;
}

#endif

//@}

/// @cond 0
/**INDENT-OFF**/
#ifdef __cplusplus
}
#endif
/**INDENT-ON**/
/// @endcond
