/*
 *  for MB9BF618T on FRK-FM3 for 240x320 pix graphic LCD of ST7781
 * 
 *   Copyright (C) by Y.Ishioka.
 */
#include "mb9b610t.h"
#include "fm3_lcd_gra1.h"
#include "fm3.h"

void gralcd_device_Initial(void) ;


/***********************************************************/
void LCD_Write_COM(volatile unsigned short data)
{
#if 1
    FM3_GPIO->PDORB &= ~0x0004 ; /* RS L */

    /* set upeer byte */
    FM3_GPIO->PDORB &= ~0x0002 ; /* /WR L */
    /* 0 clear */
    FM3_GPIO->PDOR1 &= ~0x03fc ;
    FM3_GPIO->PDORB |=  0x0002 ; /* /WR H */

    WaitNsec( 100 ) ;

    /* set lower byte */
    FM3_GPIO->PDORB &= ~0x0002 ; /* /WR L */
    FM3_GPIO->PDOR1 &= ~0x03fc ;
    FM3_GPIO->PDOR1 |= (data & 0xfc) | ((data << 8) & 0x0300) ;
    FM3_GPIO->PDORB |=  0x0002 ; /* /WR H */
#endif
}


/***********************************************************/
void LCD_Write_DATA(volatile unsigned short data)
{
#if 1
    FM3_GPIO->PDORB |=  0x0004 ; /* RS H */

    /* set upeer byte */
    FM3_GPIO->PDORB &= ~0x0002 ; /* /WR L */
    FM3_GPIO->PDOR1 &= ~0x03fc ;
    FM3_GPIO->PDOR1 |= ((data >> 8) & 0xfc) | (data & 0x0300) ;
    FM3_GPIO->PDORB |=  0x0002 ; /* /WR H */

    WaitNsec( 100 ) ;

    /* set lower byte */
    FM3_GPIO->PDORB &= ~0x0002 ; /* /WR L */
    FM3_GPIO->PDOR1 &= ~0x03fc ;
    FM3_GPIO->PDOR1 |= (data & 0xfc) | ((data << 8) & 0x0300) ;
    FM3_GPIO->PDORB |=  0x0002 ; /* /WR H */
#endif
}


/***********************************************************/
void LCD_Write_COM_DATA(volatile unsigned short index, volatile unsigned short data)
{
    LCD_Write_COM(index);
    LCD_Write_DATA(data);
    return;
}


/***********************************************************/
#define  delay  WaitMsec


/***********************************************************/
void gralcd_device_Initial(void) 
{ 
    LCD_Write_COM(0x00);
    LCD_Write_COM(0x00);
    delay(50);

    LCD_Write_COM_DATA(0x00ff, 0x0001);
    LCD_Write_COM_DATA(0x00f3, 0x0008);

	LCD_Write_COM_DATA(0x00E3, 0x3008); 
	LCD_Write_COM_DATA(0x00E7, 0x0012); 
	LCD_Write_COM_DATA(0x00EF, 0x1231); 

//    LCD_Write_COM_DATA(0xE5, 0x78F0); // set SRAM internal timing
    LCD_Write_COM_DATA(0x01, 0x0100); // set Driver Output Control  
    LCD_Write_COM_DATA(0x02, 0x0700); // set 1 line inversion  
//    LCD_Write_COM_DATA(0x03, 0x1030); // set GRAM write direction and BGR=1.  
    LCD_Write_COM_DATA(0x03, 0x1028); // set GRAM write direction and BGR=1.  
    LCD_Write_COM_DATA(0x04, 0x0000); // Resize register  
//    LCD_Write_COM_DATA(0x08, 0x0807); // set the back porch and front porch  
    LCD_Write_COM_DATA(0x08, 0x0207); // set the back porch and front porch  
    LCD_Write_COM_DATA(0x09, 0x0000); // set non-display area refresh cycle ISC[3:0]  
    LCD_Write_COM_DATA(0x0A, 0x0000); // FMARK function  
    LCD_Write_COM_DATA(0x0C, 0x0000); // RGB interface setting  
    LCD_Write_COM_DATA(0x0D, 0x0000); // Frame marker Position  
    LCD_Write_COM_DATA(0x0F, 0x0000); // RGB interface polarity  
    //*************Power On sequence ****************//
    LCD_Write_COM_DATA(0x10, 0x0790); // SAP, BT[3:0], AP, DSTB, SLP, STB  
    LCD_Write_COM_DATA(0x11, 0x0005); // DC1[2:0], DC0[2:0], VC[2:0]  
    LCD_Write_COM_DATA(0x12, 0x0000); // VREG1OUT voltage  
    LCD_Write_COM_DATA(0x13, 0x0000); // VDV[4:0] for VCOM amplitude  
    delay(200); // Dis-charge capacitor power voltage  
    LCD_Write_COM_DATA(0x10, 0x1490); // SAP, BT[3:0], AP, DSTB, SLP, STB  
    LCD_Write_COM_DATA(0x11, 0x0227); // Set DC1[2:0], DC0[2:0], VC[2:0]  
    delay(50); // Delay 50ms  
    LCD_Write_COM_DATA(0x12, 0x001c);
    delay(50); // Delay 50ms  
    LCD_Write_COM_DATA(0x13, 0x0a00); // VDV[4:0] for VCOM amplitude  
    LCD_Write_COM_DATA(0x29, 0x000f); // 04  VCM[5:0] for VCOMH  
    LCD_Write_COM_DATA(0x2B, 0x000D); // Set Frame Rate  
    delay(50); // Delay 50ms  
    LCD_Write_COM_DATA(0x20, 0x0000); // GRAM horizontal Address  
    LCD_Write_COM_DATA(0x21, 0x0000); // GRAM Vertical Address  
    // ----------- Adjust the Gamma Curve ----------//  
    LCD_Write_COM_DATA(0x30, 0x0000);  
    LCD_Write_COM_DATA(0x31, 0x0703);  
    LCD_Write_COM_DATA(0x32, 0x0001);  
    LCD_Write_COM_DATA(0x35, 0x0205);  
    LCD_Write_COM_DATA(0x36, 0x030c);  
    LCD_Write_COM_DATA(0x37, 0x0607);  
    LCD_Write_COM_DATA(0x38, 0x0405);  
    LCD_Write_COM_DATA(0x39, 0x0707);  
    LCD_Write_COM_DATA(0x3C, 0x0502);  
    LCD_Write_COM_DATA(0x3D, 0x1008);  
    //------------------ Set GRAM area ---------------//  
#if 0
    LCD_Write_COM_DATA(0x50, 0x0000); // Horizontal GRAM Start Address  
    LCD_Write_COM_DATA(0x51, 0x00EF); // Horizontal GRAM End Address  
    LCD_Write_COM_DATA(0x52, 0x0000); // Vertical GRAM Start Address  
    LCD_Write_COM_DATA(0x53, 0x013F); // Vertical GRAM Start Address  
#else
    LCD_Write_COM_DATA(0x50, 0x0000); // Horizontal GRAM Start Address  
    LCD_Write_COM_DATA(0x51, 0x013F); // Horizontal GRAM End Address  
    LCD_Write_COM_DATA(0x52, 0x0000); // Vertical GRAM Start Address  
    LCD_Write_COM_DATA(0x53, 0x00EF); // Vertical GRAM Start Address  
#endif
    LCD_Write_COM_DATA(0x60, 0xA700); // Gate Scan Line  
    LCD_Write_COM_DATA(0x61, 0x0001); // NDL,VLE, REV   
    LCD_Write_COM_DATA(0x6A, 0x0000); // set scrolling line  
    //-------------- Partial Display Control ---------//  
    LCD_Write_COM_DATA(0x80, 0x0000);  
    LCD_Write_COM_DATA(0x81, 0x0000);  
    LCD_Write_COM_DATA(0x82, 0x0000);  
    LCD_Write_COM_DATA(0x83, 0x0000);  
    LCD_Write_COM_DATA(0x84, 0x0000);  
    LCD_Write_COM_DATA(0x85, 0x0000);  
    //-------------- Panel Control -------------------//  
    LCD_Write_COM_DATA(0x60, 0xa700);  
    LCD_Write_COM_DATA(0x61, 0x0001);  
#if 0
    LCD_Write_COM_DATA(0x90, 0x0033);  
    LCD_Write_COM_DATA(0x07, 0x0133); // 262K color and display ON        
#else
	LCD_Write_COM_DATA(0x0090, 0x0010);
	LCD_Write_COM_DATA(0x0092, 0x0600); //0x0000
	LCD_Write_COM_DATA(0x0093, 0x0003);
	LCD_Write_COM_DATA(0x0095, 0x0110);
	LCD_Write_COM_DATA(0x0097, 0x0000);
	LCD_Write_COM_DATA(0x0098, 0x0000);
	LCD_Write_COM_DATA(0x0007, 0x0133); 
#endif
}


/***********************************************************/
/*
 * LCD initialize
 */
void  lcd_gra_init( void )
{
    FM3_GPIO->ADE &= ~0x000003fc ;
    WaitMsec( 50 ) ;

#if 1
    /* D0-D7 */
    FM3_GPIO->PFR1  &= ~0x03fc ; /* set GPIO to bit0-7 */
    FM3_GPIO->PCR1  &= ~0x03fc ; /* off pull-up to bit0-7 */
    FM3_GPIO->DDR1  |=  0x03fc ; /* set output mode to bit0-7 */
    FM3_GPIO->PDOR1 &= ~0x03fc ; /* clear data bit */

    /* RS:PB2 /RD:PB0 /WR:PB1 /CS:PB3 RST:PB4 */
    FM3_GPIO->PFRB  &= ~0x001f ; /* set GPIO */
    FM3_GPIO->PCRB  &= ~0x001f ; /* off pull-up */
    FM3_GPIO->DDRB  |=  0x001f ; /* set output mode */
    FM3_GPIO->PDORB &= ~0x001f ; /* clear data bit */
    FM3_GPIO->PDORB |=  0x001b ; /* set data bit */

    FM3_GPIO->PDORB &= ~0x0008 ; /* /CS L */
    WaitMsec( 50 ) ;
    FM3_GPIO->PDORB &= ~0x0010 ; /* /RST L */
    WaitMsec( 50 ) ;
    FM3_GPIO->PDORB |=  0x0010 ; /* /RST H */
    WaitMsec( 150 ) ;
    gralcd_device_Initial() ;

    WaitMsec( 50 ) ;
    WaitMsec( 50 ) ;
    FM3_GPIO->PDORB &= ~0x0010 ; /* /RST L */
    WaitMsec( 50 ) ;
    FM3_GPIO->PDORB |=  0x0010 ; /* /RST H */
    WaitMsec( 150 ) ;
    gralcd_device_Initial() ;
#endif

#if 0
    WaitMsec( 50 ) ;
    fillScreenAll() ;
#endif

#if 1
    /** for TEST PATTERN **/
  {
    unsigned int i,n,m;
    unsigned short color[8]={0xf800,0x07e0,0x001f,0x07ff,0xf81f,0xffe0,0x0000,0xffff};

    LCD_Write_COM(0x0022);
    for(n = 0; n < 8; n++)
        for(i = 0; i < 320/8; i++)
            for(m = 0; m < 240; m++)
                LCD_Write_DATA(color[n]);
  }
#endif

}
