/*
 *  for MB9BF618T on FRK-FM3
 * 
 *   Copyright (C) by Y.Ishioka.
 */
#include "mb9b610t.h"
#include "fm3.h"

/// @cond 0
/**INDENT-OFF**/
#ifdef __cplusplus
extern "C" {
#endif
/**INDENT-ON**/
/// @endcond

/***********************************************************/
/*
 * LED port initialize
 */
void  led_init( int num )
{
    switch( num ) {
    case 0:
        FM3_GPIO->ADE = FM3_GPIO->ADE & ~0x00000000 ;
        /* on board LED */
        FM3_GPIO->PFRF  &= ~0x0008 ;  /* set GPIO */
        FM3_GPIO->PCRF  &= ~0x0008 ;  /* off pull-up */
        FM3_GPIO->DDRF  |=  0x0008 ;  /* set output mode */
        FM3_GPIO->PDORF |=  0x0008 ;  /* LED off */
        break ;

    default:
        break ;
    }

}


/*
 * bit0 : 0 : LED OFF
 *        1 : LED ON
 */
void  led_set( int num, unsigned int led )
{
    switch( num ) {
    case 0 :
        if( led == 0 ) {
            FM3_GPIO->PDORF |=  0x0008 ;  /* LED off */
        } else {
            FM3_GPIO->PDORF &= ~0x0008 ;  /* LED on */
        }
        break ;

    default :
        return ;
    }
}

//@}

/// @cond 0
/**INDENT-OFF**/
#ifdef __cplusplus
}
#endif
/**INDENT-ON**/
/// @endcond
